from abc import ABC, abstractmethod

# TODO: should I differentiate between expressions and assignables?
# not all expressions can occur on the left side of an assignment: e.g. x+y = "bla" is invalid
# assignables can occur on both sides of the assignment,
# examples of assignables: a(i), a.b, a.y(i,j), and a(i).b.c(j).d(k)


class Expression(ABC):
    @abstractmethod
    def is_closed(self) -> bool:
        """
        Is the expression closed?
        I.e. are no free variables present?
        """

    @abstractmethod
    def contains_expression(self, expression) -> bool:
        """
        Does this expression contain the given expression?
        """
