from expression import Expression


class NoInterpretationExpression(Expression):
    """
    The analysis can not interpret all statements.
    The analysis did not produce an interpretation for this expression.
    """
    def __eq__(self, other) -> bool:
        return isinstance(other, NoInterpretationExpression)

    def __hash__(self) -> int:
        return 0

    def __repr__(self) -> str:
        return "[No Interpretation]"

    def is_closed(self) -> bool:
        return True

    def contains_expression(self, expression) -> bool:
        return self == expression
