from expression import Expression
from file_path import FilePath
from file_range import FileRange


class ParamAssignment:
    def __init__(self, app_expression: Expression,
                 attribute_expression: Expression,
                 value_expression: Expression,
                 file_path: FilePath,
                 file_range: FileRange
                 ):
        self.__app_expression: Expression = app_expression
        self.__attribute_expression: Expression = attribute_expression
        self.__value_expression: Expression = value_expression
        self.__file_path = file_path
        self.__file_range = file_range

    @property
    def app_expression(self) -> Expression:
        return self.__app_expression

    @property
    def attribute_expression(self) -> Expression:
        return self.__attribute_expression

    @property
    def value_expression(self) -> Expression:
        return self.__value_expression

    @property
    def file_path(self) -> FilePath:
        return self.__file_path

    @property
    def file_range(self) -> FileRange:
        return self.__file_range

    def __repr__(self) -> str:
        return '{0}({1}) = {2}'.format(str(self.__app_expression),
                                       str(self.__attribute_expression),
                                       str(self.__value_expression))
