from dataclasses import dataclass
from name import Name
from file_path import FilePath
from file_range import FileRange
from parameter import Parameter


@dataclass(frozen=True)
class ParameterDeclaration:
    name: Name
    file_path: FilePath
    file_range: FileRange
    type_name: Name

    def to_parameter_reference(self) -> Parameter:
        return Parameter(self.name,
                         self.file_path,
                         self.file_range)
