from typing import NamedTuple
from expression import Expression
from file_path import FilePath
from file_range import FileRange
from xml_generation import xml_node


class Setter(NamedTuple):
    attribute: str
    value: Expression
    file_path: FilePath
    file_range: FileRange

    def to_xml(self) -> str:
        return xml_node("setter",
                        attributes={"attribute": self.attribute,
                                    "value": str(self.value),
                                    "file": str(self.file_path),
                                    "location": str(self.file_range)
                                    })
